<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.6"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>PS2 controller TRX: C:/Users/XW8400/Documents/ps2_ctrl_trx/lib/src/ps2.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">PS2 controller TRX
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.6 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('ps2_8c.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle"><div class="title">ps2.c File Reference</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="ps2_8h_source.html">ps2.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="timer_8h_source.html">timer.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="delay_8h_source.html">delay.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="spi_8h_source.html">spi.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_n76_e003_8h_source.html">N76E003.h</a>&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a07554cecd157968692e181523268f6b4"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a07554cecd157968692e181523268f6b4">PS2_ATT_LOW</a>&#160;&#160;&#160;while(<a class="el" href="timer_8h.html#a0474b624c9c20efde212ff2753da9f69">timer_ticks</a> - ps2_last_read &lt; <a class="el" href="ps2_8h.html#ad7e2c4af69020d61f8e78ffb15f22259">PS2_DELAY_PACKET</a>); <a class="el" href="ps2_8h.html#a2989c6f2d2cd29410d3315779a8bf7d3">PS2_ATT_Px</a> &amp;= ~(1 &lt;&lt; <a class="el" href="ps2_8h.html#a8e5f482a33a2830fbc182c0b8e10a1ed">PS2_ATT_PIN</a>); <a class="el" href="delay_8h.html#a45b4ab8d2102cc0471bc9dde8c11a7fa">delay_us</a>(<a class="el" href="ps2_8h.html#a4e14d5409408a06437f6095203cf2c08">PS2_DELAY_BYTE</a>)</td></tr>
<tr class="memdesc:a07554cecd157968692e181523268f6b4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set PS2 ATT pin low.  <br /></td></tr>
<tr class="separator:a07554cecd157968692e181523268f6b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cc0d10c4525e8e764bce6a9226bb8ed"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a3cc0d10c4525e8e764bce6a9226bb8ed">PS2_ATT_HIGH</a>&#160;&#160;&#160;<a class="el" href="ps2_8h.html#a2989c6f2d2cd29410d3315779a8bf7d3">PS2_ATT_Px</a> |= (1 &lt;&lt; <a class="el" href="ps2_8h.html#a8e5f482a33a2830fbc182c0b8e10a1ed">PS2_ATT_PIN</a>); ps2_last_read = <a class="el" href="timer_8h.html#a0474b624c9c20efde212ff2753da9f69">timer_ticks</a></td></tr>
<tr class="memdesc:a3cc0d10c4525e8e764bce6a9226bb8ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set PS2 ATT pin high.  <br /></td></tr>
<tr class="separator:a3cc0d10c4525e8e764bce6a9226bb8ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06c7715e334ae41744be2728a76d513a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a06c7715e334ae41744be2728a76d513a">PS2_SPI_SETUP</a>&#160;&#160;&#160;<a class="el" href="spi_8h.html#a00174198073dadbaaad7f9475360b228">SPI_DISABLE</a>; <a class="el" href="spi_8h.html#a991dec04d2fb38979cfb0d9fc7f8b026">SPI_MODE2</a>; <a class="el" href="spi_8h.html#a7f157edf173ea33cf6ce3995da1720be">SPI_LSBFIRST</a>; <a class="el" href="_function___define_8h.html#a01a145f7891d10b5b42b7aa077981f7b">SPICLK_DIV16</a>; <a class="el" href="spi_8h.html#a27537db92d0837cc77baa0d99b8cac48">SPI_ENABLE</a></td></tr>
<tr class="memdesc:a06c7715e334ae41744be2728a76d513a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Setup SPI bus for PS2 controller.  <br /></td></tr>
<tr class="separator:a06c7715e334ae41744be2728a76d513a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:aeb8d49f2e480fd8c547f2d0a0850854a"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#aeb8d49f2e480fd8c547f2d0a0850854a">ps2_transfer</a> (unsigned char cmd)</td></tr>
<tr class="memdesc:aeb8d49f2e480fd8c547f2d0a0850854a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Transfer a packet with the PS2 controller (packet payload is stored in ps2_buffer)  <br /></td></tr>
<tr class="separator:aeb8d49f2e480fd8c547f2d0a0850854a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97a7f33f86080cd6c673f0d9f424add0"><td class="memItemLeft" align="right" valign="top">char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a97a7f33f86080cd6c673f0d9f424add0">ps2_configure</a> (void)</td></tr>
<tr class="memdesc:a97a7f33f86080cd6c673f0d9f424add0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reconfigure the PS2 controller to operate as defined by PS2_ANALOG, PS2_RUMBLE and PS2_PRESSURE (in <a class="el" href="ps2_8h.html">ps2.h</a>)  <br /></td></tr>
<tr class="separator:a97a7f33f86080cd6c673f0d9f424add0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a462521bb00ff2b45b3877478d84a5964"><td class="memItemLeft" align="right" valign="top">char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a462521bb00ff2b45b3877478d84a5964">ps2_init</a> (void)</td></tr>
<tr class="memdesc:a462521bb00ff2b45b3877478d84a5964"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize PS2 controller.  <br /></td></tr>
<tr class="separator:a462521bb00ff2b45b3877478d84a5964"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a554d47f381d48b1f2495ccbfd36d2f0b"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a554d47f381d48b1f2495ccbfd36d2f0b">ps2_poll</a> (void)</td></tr>
<tr class="memdesc:a554d47f381d48b1f2495ccbfd36d2f0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Poll readings from the PS2 controller.  <br /></td></tr>
<tr class="separator:a554d47f381d48b1f2495ccbfd36d2f0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="var-members" name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a75414ce13947efc20f73a711eb6fa246"><td class="memItemLeft" align="right" valign="top">unsigned char xdata&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="ps2_8c.html#a75414ce13947efc20f73a711eb6fa246">ps2_buffer</a> [32]</td></tr>
<tr class="memdesc:a75414ce13947efc20f73a711eb6fa246"><td class="mdescLeft">&#160;</td><td class="mdescRight">PS2 controller packet payload I/O buffer (read and written back by ps2_transfer)  <br /></td></tr>
<tr class="separator:a75414ce13947efc20f73a711eb6fa246"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a3cc0d10c4525e8e764bce6a9226bb8ed" name="a3cc0d10c4525e8e764bce6a9226bb8ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3cc0d10c4525e8e764bce6a9226bb8ed">&#9670;&#160;</a></span>PS2_ATT_HIGH</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define PS2_ATT_HIGH&#160;&#160;&#160;<a class="el" href="ps2_8h.html#a2989c6f2d2cd29410d3315779a8bf7d3">PS2_ATT_Px</a> |= (1 &lt;&lt; <a class="el" href="ps2_8h.html#a8e5f482a33a2830fbc182c0b8e10a1ed">PS2_ATT_PIN</a>); ps2_last_read = <a class="el" href="timer_8h.html#a0474b624c9c20efde212ff2753da9f69">timer_ticks</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set PS2 ATT pin high. </p>

</div>
</div>
<a id="a07554cecd157968692e181523268f6b4" name="a07554cecd157968692e181523268f6b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07554cecd157968692e181523268f6b4">&#9670;&#160;</a></span>PS2_ATT_LOW</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define PS2_ATT_LOW&#160;&#160;&#160;while(<a class="el" href="timer_8h.html#a0474b624c9c20efde212ff2753da9f69">timer_ticks</a> - ps2_last_read &lt; <a class="el" href="ps2_8h.html#ad7e2c4af69020d61f8e78ffb15f22259">PS2_DELAY_PACKET</a>); <a class="el" href="ps2_8h.html#a2989c6f2d2cd29410d3315779a8bf7d3">PS2_ATT_Px</a> &amp;= ~(1 &lt;&lt; <a class="el" href="ps2_8h.html#a8e5f482a33a2830fbc182c0b8e10a1ed">PS2_ATT_PIN</a>); <a class="el" href="delay_8h.html#a45b4ab8d2102cc0471bc9dde8c11a7fa">delay_us</a>(<a class="el" href="ps2_8h.html#a4e14d5409408a06437f6095203cf2c08">PS2_DELAY_BYTE</a>)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set PS2 ATT pin low. </p>

</div>
</div>
<a id="a06c7715e334ae41744be2728a76d513a" name="a06c7715e334ae41744be2728a76d513a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a06c7715e334ae41744be2728a76d513a">&#9670;&#160;</a></span>PS2_SPI_SETUP</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define PS2_SPI_SETUP&#160;&#160;&#160;<a class="el" href="spi_8h.html#a00174198073dadbaaad7f9475360b228">SPI_DISABLE</a>; <a class="el" href="spi_8h.html#a991dec04d2fb38979cfb0d9fc7f8b026">SPI_MODE2</a>; <a class="el" href="spi_8h.html#a7f157edf173ea33cf6ce3995da1720be">SPI_LSBFIRST</a>; <a class="el" href="_function___define_8h.html#a01a145f7891d10b5b42b7aa077981f7b">SPICLK_DIV16</a>; <a class="el" href="spi_8h.html#a27537db92d0837cc77baa0d99b8cac48">SPI_ENABLE</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Setup SPI bus for PS2 controller. </p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a97a7f33f86080cd6c673f0d9f424add0" name="a97a7f33f86080cd6c673f0d9f424add0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a97a7f33f86080cd6c673f0d9f424add0">&#9670;&#160;</a></span>ps2_configure()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char ps2_configure </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Reconfigure the PS2 controller to operate as defined by PS2_ANALOG, PS2_RUMBLE and PS2_PRESSURE (in <a class="el" href="ps2_8h.html">ps2.h</a>) </p>
<dl class="section return"><dt>Returns</dt><dd>0 on success, 1 if escape (configuration) mode can't be entered, 2 if controller mode can't be set, 3 if polling result fields can't be set, 4 if vibrators can't be enabled, 5 if escape mode can't be exited, 6 if the controller doesn't respond to the exit command, or 7 if the controller doesn't respond to mode switch </dd></dl>

</div>
</div>
<a id="a462521bb00ff2b45b3877478d84a5964" name="a462521bb00ff2b45b3877478d84a5964"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a462521bb00ff2b45b3877478d84a5964">&#9670;&#160;</a></span>ps2_init()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char ps2_init </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialize PS2 controller. </p>
<dl class="section return"><dt>Returns</dt><dd>Return 1 if controller can't be polled, else return 0 </dd></dl>

</div>
</div>
<a id="a554d47f381d48b1f2495ccbfd36d2f0b" name="a554d47f381d48b1f2495ccbfd36d2f0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a554d47f381d48b1f2495ccbfd36d2f0b">&#9670;&#160;</a></span>ps2_poll()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char ps2_poll </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Poll readings from the PS2 controller. </p>
<dl class="section return"><dt>Returns</dt><dd>0 on reconfiguration failure, or the return value of the poll command (see ps2_transfer). The retrieved readings are also stored in ps2_buffer, and can be interpreted using the PS2_DIG_* and PS2_ANA_* macros. </dd></dl>

</div>
</div>
<a id="aeb8d49f2e480fd8c547f2d0a0850854a" name="aeb8d49f2e480fd8c547f2d0a0850854a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeb8d49f2e480fd8c547f2d0a0850854a">&#9670;&#160;</a></span>ps2_transfer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char ps2_transfer </td>
          <td>(</td>
          <td class="paramtype">unsigned char&#160;</td>
          <td class="paramname"><em>cmd</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Transfer a packet with the PS2 controller (packet payload is stored in ps2_buffer) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">cmd</td><td>The command to be sent to the controller </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A byte containing the controller's mode and packet payload size (in words), which can be retrieved using the ps2_transfer_mode and ps2_transfer_words macros respectively. The controller's response payload is also returned in ps2_buffer. </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="a75414ce13947efc20f73a711eb6fa246" name="a75414ce13947efc20f73a711eb6fa246"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a75414ce13947efc20f73a711eb6fa246">&#9670;&#160;</a></span>ps2_buffer</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char xdata ps2_buffer[32]</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>PS2 controller packet payload I/O buffer (read and written back by ps2_transfer) </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_b116ddd94a245d490f1483cfe96d55a6.html">ps2_ctrl_trx</a></li><li class="navelem"><a class="el" href="dir_1a84bb234c89b52eac6ccacceb8c95a3.html">lib</a></li><li class="navelem"><a class="el" href="dir_5eaeabca49434b85d2268f40b691c39f.html">src</a></li><li class="navelem"><a class="el" href="ps2_8c.html">ps2.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.6 </li>
  </ul>
</div>
</body>
</html>
